
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#include "StdAfx.h"
#include "ColorPalette.h"

using namespace AutomateIT::CalcItems;

int CColorPalette::colors_[] = 
{
    0x000000,    0xFFFFFF,    0x0000FF,    0x00FF00,    0xFF0000,    0x00FFFF,    0xFF00FF,
    0xFFFF00,    0x000080,    0x008000,    0x800000,    0x008080,    0x800080,    0x808000,
    0xC0C0C0,    0x808080,    0xFF9999,    0x663399,    0xCCFFFF,    0xFFFFCC,    0x660066,
    0x8080FF,    0xCC6600,    0xFFCCCC,    0x800000,    0xFF00FF,    0x00FFFF,    0xFFFF00,
    0x800080,    0x000080,    0x808000,    0xFF0000,    0xFFCC00,    0xFFFFCC,    0xCCFFCC,
    0x99FFFF,    0xFFCC99,    0xCC99FF,    0xFF99CC,    0x99CCFF,    0xFF6633,    0xCCCC33,
    0x00CC99,    0x00CCFF,    0x0099FF,    0x0066FF,    0x996666,    0x969696,    0x663300,
    0x669933,    0x003300,    0x003333,    0x003399,    0x663399,    0x993333,    0x333333
};
    

int CColorPalette::GetColor( int index )
{
    const int tableSize = sizeof (colors_) / sizeof (int);
    if (index < 0 || index >= tableSize)
    {
        throw std::out_of_range("Invalid ColorPalette index");
    }
    return ConvertRGB(colors_[index]);
}

int CColorPalette::GetColorIndex( int color )
{
    const int tableSize = sizeof (colors_) / sizeof (int);
    for (int i = 0; i < tableSize; ++i)
    {
        if ((0x00ffffff & color) == colors_[i])
        {
            return i;
        }
    }
    return 0;
}

int CColorPalette::ConvertRGB( int rgbColor )
{
    return ((0x00FF0000 & rgbColor) >> 16) | 
           ((0x0000FF00 & rgbColor)) |
           ((0x000000FF & rgbColor) << 16 );
}