
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _FONT_H_
#define _FONT_H_

#include "ExcelClone.h"

/*
	CFont class represents Font Excel object. It contains the font attributes 
	(font name, font size, color, and so on) for an object.
*/

namespace AutomateIT
{
	namespace ExcelClone
	{
		class CRange;

		class ATL_NO_VTABLE CFont :
			public CComObjectRootEx<CComSingleThreadModel>,
			public IDispatchImpl<Font, &IID_Font, &LIBID_ExcelCloneLib, 1, 0>
		{
		public:
			CFont();
			virtual ~CFont();

			BEGIN_COM_MAP(CFont)
				COM_INTERFACE_ENTRY(Font)
				COM_INTERFACE_ENTRY(IDispatch)
			END_COM_MAP()

		public:


              HRESULT __stdcall get_Application( 
                 _Application **RHS);

              HRESULT __stdcall get_Creator( 
                 XlCreator *RHS);

              HRESULT __stdcall get_Parent( 
                 IDispatch **RHS);

              HRESULT __stdcall get_Background( 
                 VARIANT *RHS);

              HRESULT __stdcall put_Background( 
                 VARIANT RHS);

              HRESULT __stdcall get_Bold( 
                 VARIANT *RHS);

              HRESULT __stdcall put_Bold( 
                 VARIANT RHS);

              HRESULT __stdcall get_Color( 
                 VARIANT *RHS);

              HRESULT __stdcall put_Color( 
                 VARIANT RHS);

              HRESULT __stdcall get_ColorIndex( 
                 VARIANT *RHS);

              HRESULT __stdcall put_ColorIndex( 
                 VARIANT RHS);

              HRESULT __stdcall get_FontStyle( 
                 VARIANT *RHS);

              HRESULT __stdcall put_FontStyle( 
                 VARIANT RHS);

              HRESULT __stdcall get_Italic( 
                 VARIANT *RHS);

              HRESULT __stdcall put_Italic( 
                 VARIANT RHS);

              HRESULT __stdcall get_Name( 
                 VARIANT *RHS);

              HRESULT __stdcall put_Name( 
                 VARIANT RHS);

              HRESULT __stdcall get_OutlineFont( 
                 VARIANT *RHS);

              HRESULT __stdcall put_OutlineFont( 
                 VARIANT RHS);

              HRESULT __stdcall get_Shadow( 
                 VARIANT *RHS);

              HRESULT __stdcall put_Shadow( 
                 VARIANT RHS);

              HRESULT __stdcall get_Size( 
                 VARIANT *RHS);

              HRESULT __stdcall put_Size( 
                 VARIANT RHS);

              HRESULT __stdcall get_Strikethrough( 
                 VARIANT *RHS);

              HRESULT __stdcall put_Strikethrough( 
                 VARIANT RHS);

              HRESULT __stdcall get_Subscript( 
                 VARIANT *RHS);

              HRESULT __stdcall put_Subscript( 
                 VARIANT RHS);

              HRESULT __stdcall get_Superscript( 
                 VARIANT *RHS);

              HRESULT __stdcall put_Superscript( 
                 VARIANT RHS);

              HRESULT __stdcall get_Underline( 
                 VARIANT *RHS);

              HRESULT __stdcall put_Underline( 
                 VARIANT RHS);

		public:
			STDMETHOD(Initialize)(CRangePtr pRange);

		protected:
			CRangePtr m_pRange;
		};

		typedef CComObject<CFont> CFontObject;
		typedef CComPtr<CFont> CFontPtr;
	}
}

#endif //_FONT_H_