/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#include "StdAfx.h"
#include "Interior.h"

using namespace AutomateIT::ExcelClone;
using namespace AutomateIT::CalcItems;
using namespace AutomateIT::Utils;

CInterior::CInterior() :
    m_pRange(NULL)
{
    TRACINGMETHOD;
}

CInterior::~CInterior()
{
    TRACINGMETHOD;
}

HRESULT __stdcall AutomateIT::ExcelClone::CInterior::Initialize( CRangePtr pPange )
{
    TRACINGMETHOD;
    m_pRange = pPange;
    return hr;
}

HRESULT __stdcall CInterior::get_Application( 
    _Application **RHS)
{
    TRACINGMETHOD;
    return m_pRange->get_Application(RHS);
}

HRESULT __stdcall CInterior::get_Creator( 
    XlCreator *RHS)
{
    TRACINGMETHOD;
    (*RHS) = xlCreatorCode;
    return hr;
}

HRESULT __stdcall CInterior::get_Parent( 
    IDispatch **RHS)
{
    TRACINGMETHOD;
    (*RHS) = m_pRange;
    (*RHS)->AddRef();
    return hr;
}

HRESULT __stdcall CInterior::get_Color( 
    VARIANT *RHS)
{
    TRACINGMETHOD; 
    int color(0);
    hr = m_pRange->GetRangeObject()->get_cellBackColor(&color);
    CHECKERROR;
    (*RHS) = CComVariant(CColorPalette::ConvertRGB(color));
    return hr; 
}

HRESULT __stdcall CInterior::put_Color( 
    VARIANT RHS)
{ 
    TRACINGMETHOD; 
    hr = m_pRange->GetRangeObject()->put_IsCellBackgroundTransparent(true);
    CHECKERROR;

    CComVariant param(RHS);
    hr = param.ChangeType(VT_I4);
    CHECKERROR;

    hr = m_pRange->GetRangeObject()->put_cellBackColor(param.intVal);
    CHECKERROR;
    return hr;
}

HRESULT __stdcall CInterior::get_ColorIndex( 
    VARIANT *RHS)
{
    TRACINGMETHOD;
    int color(0);
    hr = m_pRange->GetRangeObject()->get_cellBackColor(&color);
    CHECKERROR;
    (*RHS) = CComVariant(CColorPalette::GetColorIndex(CColorPalette::ConvertRGB(color)) + 1);
    return hr;
}

HRESULT __stdcall CInterior::put_ColorIndex( 
    VARIANT RHS)
{ 
    TRACINGMETHOD; 
    CComVariant colorIndex(RHS);
    hr = colorIndex.ChangeType(VT_I4);
    CHECKERROR;
    if (colorIndex.intVal == xlColorIndexNone) 
    {
        colorIndex.intVal = 2;
    }
    if (colorIndex.intVal == xlColorIndexAutomatic) 
    {
        colorIndex.intVal = 1;
    }
    if (colorIndex.intVal == 0) 
    {
        colorIndex.intVal = 2;
    }

    hr = put_Color(CComVariant(CColorPalette::GetColor(colorIndex.intVal - 1)));
    return hr;
}

HRESULT __stdcall CInterior::get_InvertIfNegative( 
    VARIANT *RHS)
{
	TRACINGMETHOD;
    TRACINGNOTIMPL;
	return S_OK;
}

HRESULT __stdcall CInterior::put_InvertIfNegative( 
    VARIANT RHS)
{
	TRACINGMETHOD;
    TRACINGNOTIMPL;
	return S_OK;
}

HRESULT __stdcall CInterior::get_Pattern( 
    VARIANT *RHS)
{ 
    TRACINGMETHOD; 
    // OOo does not support yet different fill patterns
    // It always returns Solid pattern
    (*RHS) = CComVariant(xlSolid);
    return hr; 
}

HRESULT __stdcall CInterior::put_Pattern( 
    VARIANT RHS)
{ 
    TRACINGMETHOD; 
    // OOo does not support yet different fill patterns
    return hr; 
}

HRESULT __stdcall CInterior::get_PatternColor( 
    VARIANT *RHS)
{
	TRACINGMETHOD;
    TRACINGNOTIMPL;
	return S_OK;
}

HRESULT __stdcall CInterior::put_PatternColor( 
    VARIANT RHS)
{
	TRACINGMETHOD;
    TRACINGNOTIMPL;
	return S_OK;
}

HRESULT __stdcall CInterior::get_PatternColorIndex( 
    VARIANT *RHS)
{
	TRACINGMETHOD;
    TRACINGNOTIMPL;
	return S_OK;
}

HRESULT __stdcall CInterior::put_PatternColorIndex( 
    VARIANT RHS)
{
	TRACINGMETHOD;
    TRACINGNOTIMPL;
	return S_OK;
}

