/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#include "StdAfx.h"
#include "OOBorderLine.h"

using namespace AutomateIT::Utils;
using namespace AutomateIT::OpenOfficeWrapper;

COOBorderLine::COOBorderLine()
{
}

COOBorderLine::~COOBorderLine()
{
}


HRESULT COOBorderLine::Initialize( IDispatchPtr dispatch )
{
    m_pdBorderLine = dispatch;
    return S_OK;
}

HRESULT COOBorderLine::get_InnerLineWidth( long* plInnerLineWidth )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdBorderLine, L"InnerLineWidth", 0);
    CHECKERROR;
    (*plInnerLineWidth) = result.lVal;
    return hr;
}

HRESULT COOBorderLine::put_InnerLineWidth( long lInnerLineWidth )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdBorderLine, L"InnerLineWidth", 1, CComVariant(lInnerLineWidth));
    CHECKERROR;
    return hr;
}

HRESULT COOBorderLine::get_OuterLineWidth( long* plOuterLineWidth )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdBorderLine, L"OuterLineWidth", 0);
    CHECKERROR;
    (*plOuterLineWidth) = result.lVal;
    return hr;
}

HRESULT COOBorderLine::put_OuterLineWidth( long lOuterLineWidth )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdBorderLine, L"OuterLineWidth", 1, CComVariant(lOuterLineWidth));
    CHECKERROR;
    return hr;
}

HRESULT COOBorderLine::get_LineDistance( long* plLineDistance )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdBorderLine, L"LineDistance", 0);
    CHECKERROR;
    (*plLineDistance) = result.lVal;
    return hr;
}

HRESULT COOBorderLine::put_LineDistance( long lLineDistance )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdBorderLine, L"LineDistance", 1, CComVariant(lLineDistance));
    CHECKERROR;
    return hr;
}

HRESULT COOBorderLine::get_Color( int* piColor )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdBorderLine, L"Color", 0);
    CHECKERROR;
    (*piColor) = result.lVal;
    return hr;
}

HRESULT COOBorderLine::put_Color( int iColor )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdBorderLine, L"Color", 1, CComVariant(iColor));
    CHECKERROR;
    return hr;
}