
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _OO_CALC_DOCUMENT_H_
#define _OO_CALC_DOCUMENT_H_

#pragma once

#include "OODocument.h"

namespace AutomateIT
{
    namespace OpenOfficeWrapper
    {
        class COOSheets;
        class COONumberFormats;

        class ATL_NO_VTABLE COOCalcDocument : 
            public CComObjectRootEx<CComSingleThreadModel>,
            public IUnknown
        {
        public:

            BEGIN_COM_MAP(COOCalcDocument)
                COM_INTERFACE_ENTRY(IUnknown)
            END_COM_MAP( )

            COOCalcDocument();
            virtual ~COOCalcDocument();

            HRESULT Attach(COODocumentPtr pDoc);
            HRESULT Detach();

            HRESULT GetSheets(COOSheets** ppSheets);

            HRESULT get_NumberFormats(COONumberFormats** ppOONumberFormats);

            HRESULT get_CurrentSelection(COORange** pOORange);

            HRESULT get_ActiveSheet(COORange** ppOORange);
            HRESULT put_ActiveSheet(COORange* pOORange);

            HRESULT Select(COORange* pOORange);

            HRESULT Protect(BSTR bstrPassword);
            HRESULT Unprotect(BSTR bstrPassword);

            COODocumentPtr GetDocument() const;


        private:

            COODocumentPtr m_pDoc;

        };

        typedef CComPtr<COOCalcDocument> COOCalcDocumentPtr;
        typedef CComObject<COOCalcDocument> COOCalcDocumentObject;

    }
}

#endif // _OO_CALC_DOCUMENT_H_