/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#include "StdAfx.h"
#include "OOColumns.h"

using namespace AutomateIT::Utils;
using namespace AutomateIT::OpenOfficeWrapper;

COOColumns::COOColumns()
{
}

COOColumns::~COOColumns()
{
}

HRESULT COOColumns::Initialize( IDispatchPtr dispatch )
{
    m_pdColumns = dispatch;
    return S_OK;
}

HRESULT COOColumns::get_Width( int* piWidth )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdColumns, L"Width", 0);
    CHECKERROR;
    (*piWidth) = result.intVal;
    return hr;
}

HRESULT COOColumns::put_Width( int iWidth )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdColumns, L"Width", 1, CComVariant(iWidth));
    //CHECKERROR;
    //return hr;
    return S_OK;
}

HRESULT COOColumns::RemoveByIndex( long index, long count )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_METHOD, &result, m_pdColumns, L"removeByIndex", 2, CComVariant(index), CComVariant(count));
    CHECKERROR;
    return hr;
}

HRESULT COOColumns::InsertByIndex( long index, long count )
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_METHOD, &result, m_pdColumns, L"insertByIndex", 2, CComVariant(index), CComVariant(count));
    CHECKERROR;
    return hr;
}

