
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _OO_ENUMERATION_H_
#define _OO_ENUMERATION_H_

#pragma once

#include "IDispatchWrapper.h"

namespace AutomateIT
{
    namespace OpenOfficeWrapper
    {
        class ATL_NO_VTABLE COOEnumeration : 
            public CComObjectRootEx<CComSingleThreadModel>,
            public IUnknown
        {
        public:

            BEGIN_COM_MAP(COOEnumeration)
                COM_INTERFACE_ENTRY(IUnknown)
            END_COM_MAP( )

            COOEnumeration();
            virtual ~COOEnumeration();

            HRESULT Initialize(IDispatchPtr dispatch);
            HRESULT HasMoreElements(bool* pValue);
            HRESULT NextElement(IDispatch** ppValue);

        private:

            IDispatchPtr m_pdEnumeration;

        };

        typedef CComPtr<COOEnumeration> COOEnumerationPtr;
        typedef CComObject<COOEnumeration> COOEnumerationObject;

    }
}

#endif // _OO_ENUMERATION_H_
