/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#include "StdAfx.h"
#include "OOPageSetupStyle.h"

using namespace AutomateIT::Utils;
using namespace AutomateIT::OpenOfficeWrapper;

COOPageSetupStyle::COOPageSetupStyle()
{
}

COOPageSetupStyle::~COOPageSetupStyle()
{
}

HRESULT COOPageSetupStyle::Initialize(IDispatchPtr dispatch)
{
    m_pdPageSetupStyle = dispatch;
    return S_OK;
}

HRESULT COOPageSetupStyle::get_LeftMargin(int* piLeftMargin)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdPageSetupStyle, L"LeftMargin", 0);
    CHECKERROR;
    (*piLeftMargin) = result.intVal;
    return hr;
}

HRESULT COOPageSetupStyle::put_LeftMargin(int iLeftMargin)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdPageSetupStyle, L"LeftMargin", 1, CComVariant(iLeftMargin));
    CHECKERROR;
    return hr;
}

HRESULT COOPageSetupStyle::get_RightMargin(int* piRightMargin)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdPageSetupStyle, L"RightMargin", 0);
    CHECKERROR;
    (*piRightMargin) = result.intVal;
    return hr;
}

HRESULT COOPageSetupStyle::put_RightMargin(int iRightMargin)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdPageSetupStyle, L"RightMargin", 1, CComVariant(iRightMargin));
    CHECKERROR;
    return hr;
}

HRESULT COOPageSetupStyle::get_TopMargin(int* piTopMargin)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdPageSetupStyle, L"TopMargin", 0);
    CHECKERROR;
    (*piTopMargin) = result.intVal;
    return hr;
}

HRESULT COOPageSetupStyle::put_TopMargin(int iTopMargin)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdPageSetupStyle, L"TopMargin", 1, CComVariant(iTopMargin));
    CHECKERROR;
    return hr;
}

HRESULT COOPageSetupStyle::get_BottomMargin(int* piBottomMargin)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdPageSetupStyle, L"BottomMargin", 0);
    CHECKERROR;
    (*piBottomMargin) = result.intVal;
    return hr;
}

HRESULT COOPageSetupStyle::put_BottomMargin(int iBottomMargin)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdPageSetupStyle, L"BottomMargin", 1, CComVariant(iBottomMargin));
    CHECKERROR;
    return hr;
}

HRESULT COOPageSetupStyle::get_IsLandscape(bool* pbIsLandscape)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdPageSetupStyle, L"IsLandscape", 0);
    CHECKERROR;
    (*pbIsLandscape) = result.boolVal != VARIANT_FALSE;
    return hr;
}

HRESULT COOPageSetupStyle::put_IsLandscape(bool bIsLandscape)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdPageSetupStyle, L"IsLandscape", 1, CComVariant(bIsLandscape));
    CHECKERROR;
    return hr;
}

HRESULT COOPageSetupStyle::get_PageScale(short* psPageScale)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdPageSetupStyle, L"PageScale", 0);
    CHECKERROR;
    (*psPageScale) = result.iVal;
    return hr;
}

HRESULT COOPageSetupStyle::put_PageScale(short sPageScale)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdPageSetupStyle, L"PageScale", 1, CComVariant(sPageScale));
    CHECKERROR;
    return hr;
}

HRESULT COOPageSetupStyle::get_ScaleToPagesY(short* psScaleToPagesY)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdPageSetupStyle, L"ScaleToPagesY", 0);
    CHECKERROR;
    (*psScaleToPagesY) = result.iVal;
    return hr;
}

HRESULT COOPageSetupStyle::put_ScaleToPagesY(short sScaleToPagesY)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdPageSetupStyle, L"ScaleToPagesY", 1, CComVariant(sScaleToPagesY));
    CHECKERROR;
    return hr;
}


HRESULT COOPageSetupStyle::get_ScaleToPagesX(short* psScaleToPagesX)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdPageSetupStyle, L"ScaleToPagesX", 0);
    CHECKERROR;
    (*psScaleToPagesX) = result.iVal;
    return hr;
}

HRESULT COOPageSetupStyle::put_ScaleToPagesX(short sScaleToPagesX)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdPageSetupStyle, L"ScaleToPagesX", 1, CComVariant(sScaleToPagesX));
    CHECKERROR;
    return hr;
}


HRESULT COOPageSetupStyle::get_HeaderHeight(long* plHeaderHeight)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdPageSetupStyle, L"HeaderHeight", 0);
    CHECKERROR;
    (*plHeaderHeight) = result.lVal;
    return hr;
}

HRESULT COOPageSetupStyle::put_HeaderHeight(long lHeaderHeight)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdPageSetupStyle, L"HeaderHeight", 1, CComVariant(lHeaderHeight));
    CHECKERROR;
    return hr;
}

HRESULT COOPageSetupStyle::get_FooterHeight(long* plFooterHeight)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdPageSetupStyle, L"FooterHeight", 0);
    CHECKERROR;
    (*plFooterHeight) = result.lVal;
    return hr;
}

HRESULT COOPageSetupStyle::put_FooterHeight(long lFooterHeight)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdPageSetupStyle, L"FooterHeight", 1, CComVariant(lFooterHeight));
    CHECKERROR;
    return hr;
}

HRESULT COOPageSetupStyle::get_CenterHorizontally(bool* pbCenterHorizontally)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdPageSetupStyle, L"CenterHorizontally", 0);
    CHECKERROR;
    (*pbCenterHorizontally) = result.boolVal != VARIANT_FALSE;
    return hr;
}

HRESULT COOPageSetupStyle::put_CenterHorizontally(bool bCenterHorizontally)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdPageSetupStyle, L"CenterHorizontally", 1, CComVariant(bCenterHorizontally));
    CHECKERROR;
    return hr;
}

HRESULT COOPageSetupStyle::get_CenterVertically(bool* pbCenterVertically)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYGET, &result, m_pdPageSetupStyle, L"CenterVertically", 0);
    CHECKERROR;
    (*pbCenterVertically) = result.boolVal != VARIANT_FALSE;
    return hr;
}

HRESULT COOPageSetupStyle::put_CenterVertically(bool bCenterVertically)
{
    CComVariant result;
    HRESULT hr = AutoWrapper::Execute(DISPATCH_PROPERTYPUT, &result, m_pdPageSetupStyle, L"CenterVertically", 1, CComVariant(bCenterVertically));
    CHECKERROR;
    return hr;
}

