
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _WORD_DOCUMENTS_COLLECTION_H_
#define _WORD_DOCUMENTS_COLLECTION_H_

#include <atlcom.h>
#include <atlcoll.h>
#include "resource.h"
#include "WordClone.h"
#include "WordDocument.h"

namespace AutomateIT
{
	namespace WordClone
	{
		class CWordDocument;

		class ATL_NO_VTABLE CWordDocumentsCollection : 
			public CComObjectRootEx<CComSingleThreadModel>,
			public IDispatchImpl<Documents, &__uuidof(Documents), &LIBID_WordCloneLib, 8, 3>
		{
		public:
			//DECLARE_REGISTRY_RESOURCEID(IDR_WORDDOCUMENTS)

			BEGIN_COM_MAP(CWordDocumentsCollection)
				COM_INTERFACE_ENTRY(Documents)
			END_COM_MAP()

			DECLARE_PROTECT_FINAL_CONSTRUCT()

			HRESULT FinalConstruct()
			{
				return S_OK;
			}

			void FinalRelease() 
			{
			}

			CWordDocumentsCollection();
			virtual ~CWordDocumentsCollection();
			
			// Documents interface methods
		public:
			STDMETHOD(get__NewEnum)(LPUNKNOWN* prop);
			STDMETHOD(get_Count)(long* prop);
			STDMETHOD(get_Application)(IApplication** prop);
			STDMETHOD(get_Creator)(long* prop);
			STDMETHOD(get_Parent)(LPDISPATCH* prop);
			STDMETHOD(get_Item)(VARIANT* index, _Document** doc);
			STDMETHOD(Close)(VARIANT* SaveChanges, VARIANT* OriginalFormat, VARIANT* RouteDocument);
			STDMETHOD(AddOld)(VARIANT* Template, VARIANT* NewTemplate, _Document** prop);
			STDMETHOD(OpenOld)(VARIANT* FileName, VARIANT* ConfirmConversions, VARIANT* ReadOnly, VARIANT* AddToRecentFiles, VARIANT* PasswordDocument, VARIANT* PasswordTemplate, VARIANT* Revert, VARIANT* WritePasswordDocument, VARIANT* WritePasswordTemplate, VARIANT* Format, _Document** prop);
			STDMETHOD(Save)(VARIANT* NoPrompt, VARIANT* OriginalFormat);
			STDMETHOD(Add)(VARIANT* Template, VARIANT* NewTemplate, VARIANT* DocumentType, VARIANT* Visible, _Document** prop);
			STDMETHOD(Open2000)(VARIANT* FileName, VARIANT* ConfirmConversions, VARIANT* ReadOnly, VARIANT* AddToRecentFiles, VARIANT* PasswordDocument, VARIANT* PasswordTemplate, VARIANT* Revert, VARIANT* WritePasswordDocument, VARIANT* WritePasswordTemplate, VARIANT* Format, VARIANT* Encoding, VARIANT* Visible, _Document** prop);
			STDMETHOD(CheckOut)(BSTR FileName);
			STDMETHOD(CanCheckOut)(BSTR FileName, VARIANT_BOOL* prop);
			STDMETHOD(Open2002)(VARIANT* FileName, VARIANT* ConfirmConversions, VARIANT* ReadOnly, VARIANT* AddToRecentFiles, VARIANT* PasswordDocument, VARIANT* PasswordTemplate, VARIANT* Revert, VARIANT* WritePasswordDocument, VARIANT* WritePasswordTemplate, VARIANT* Format, VARIANT* Encoding, VARIANT* Visible, VARIANT* OpenAndRepair, VARIANT* DocumentDirection, VARIANT* NoEncodingDialog, _Document** prop);
			STDMETHOD(Open)(VARIANT* FileName, VARIANT* ConfirmConversions, VARIANT* ReadOnly, VARIANT* AddToRecentFiles, VARIANT* PasswordDocument, VARIANT* PasswordTemplate, VARIANT* Revert, VARIANT* WritePasswordDocument, VARIANT* WritePasswordTemplate, VARIANT* Format, VARIANT* Encoding, VARIANT* Visible, VARIANT* OpenAndRepair, VARIANT* DocumentDirection, VARIANT* NoEncodingDialog, VARIANT* XMLTransform, _Document** prop);
		};
	}
}

#endif //_WORD_DOCUMENTS_COLLECTION_H_