
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _WORD_FONT_H_
#define _WORD_FONT_H_

#include <atlcom.h>
#include "resource.h"       
#include "WordClone.h"

namespace AutomateIT
{
	namespace WordClone
	{
		class ATL_NO_VTABLE CWordFont :
			public CComObjectRootEx<CComSingleThreadModel>,
			public IDispatchImpl<_Font, &__uuidof(_Font), &LIBID_WordCloneLib, 8, 3>
		{
		public:
			CWordFont();
			virtual ~CWordFont();

			BEGIN_COM_MAP(CWordFont)
				COM_INTERFACE_ENTRY(_Font)
			END_COM_MAP()

		public:
			// _Font Methods
			STDMETHOD(get_Application)(IApplication** prop);
			STDMETHOD(get_Creator)(long* prop);
			STDMETHOD(get_Parent)(LPDISPATCH* prop);
			STDMETHOD(get_Duplicate)(_Font** prop);
			STDMETHOD(get_Bold)(long* prop);
			STDMETHOD(put_Bold)(long prop);
			STDMETHOD(get_Italic)(long* prop);
			STDMETHOD(put_Italic)(long prop);
			STDMETHOD(get_Hidden)(long* prop);
			STDMETHOD(put_Hidden)(long prop);
			STDMETHOD(get_SmallCaps)(long* prop);
			STDMETHOD(put_SmallCaps)(long prop);
			STDMETHOD(get_AllCaps)(long* prop);
			STDMETHOD(put_AllCaps)(long prop);
			STDMETHOD(get_StrikeThrough)(long* prop);
			STDMETHOD(put_StrikeThrough)(long prop);
			STDMETHOD(get_DoubleStrikeThrough)(long* prop);
			STDMETHOD(put_DoubleStrikeThrough)(long prop);
			STDMETHOD(get_ColorIndex)(WdColorIndex* prop);
			STDMETHOD(put_ColorIndex)(WdColorIndex prop);
			STDMETHOD(get_Subscript)(long* prop);
			STDMETHOD(put_Subscript)(long prop);
			STDMETHOD(get_Superscript)(long* prop);
			STDMETHOD(put_Superscript)(long prop);
			STDMETHOD(get_Underline)(WdUnderline* prop);
			STDMETHOD(put_Underline)(WdUnderline prop);
			STDMETHOD(get_Size)(float* prop);
			STDMETHOD(put_Size)(float prop);
			STDMETHOD(get_Name)(BSTR* prop);
			STDMETHOD(put_Name)(BSTR prop);
			STDMETHOD(get_Position)(long* prop);
			STDMETHOD(put_Position)(long prop);
			STDMETHOD(get_Spacing)(float* prop);
			STDMETHOD(put_Spacing)(float prop);
			STDMETHOD(get_Scaling)(long* prop);
			STDMETHOD(put_Scaling)(long prop);
			STDMETHOD(get_Shadow)(long* prop);
			STDMETHOD(put_Shadow)(long prop);
			STDMETHOD(get_Outline)(long* prop);
			STDMETHOD(put_Outline)(long prop);
			STDMETHOD(get_Emboss)(long* prop);
			STDMETHOD(put_Emboss)(long prop);
			STDMETHOD(get_Kerning)(float* prop);
			STDMETHOD(put_Kerning)(float prop);
			STDMETHOD(get_Engrave)(long* prop);
			STDMETHOD(put_Engrave)(long prop);
			STDMETHOD(get_Animation)(WdAnimation* prop);
			STDMETHOD(put_Animation)(WdAnimation prop);
			STDMETHOD(get_Borders)(IDispatch** prop);
			STDMETHOD(put_Borders)(IDispatch* prop);
			STDMETHOD(get_Shading)(IDispatch** prop);
			STDMETHOD(get_EmphasisMark)(WdEmphasisMark* prop);
			STDMETHOD(put_EmphasisMark)(WdEmphasisMark prop);
			STDMETHOD(get_DisableCharacterSpaceGrid)(VARIANT_BOOL* prop);
			STDMETHOD(put_DisableCharacterSpaceGrid)(VARIANT_BOOL prop);
			STDMETHOD(get_NameFarEast)(BSTR* prop);
			STDMETHOD(put_NameFarEast)(BSTR prop);
			STDMETHOD(get_NameAscii)(BSTR* prop);
			STDMETHOD(put_NameAscii)(BSTR prop);
			STDMETHOD(get_NameOther)(BSTR* prop);
			STDMETHOD(put_NameOther)(BSTR prop);
			STDMETHOD(Grow)();
			STDMETHOD(Shrink)();
			STDMETHOD(Reset)();
			STDMETHOD(SetAsTemplateDefault)();
			STDMETHOD(get_Color)(WdColor* prop);
			STDMETHOD(put_Color)(WdColor prop);
			STDMETHOD(get_BoldBi)(long* prop);
			STDMETHOD(put_BoldBi)(long prop);
			STDMETHOD(get_ItalicBi)(long* prop);
			STDMETHOD(put_ItalicBi)(long prop);
			STDMETHOD(get_SizeBi)(float* prop);
			STDMETHOD(put_SizeBi)(float prop);
			STDMETHOD(get_NameBi)(BSTR* prop);
			STDMETHOD(put_NameBi)(BSTR prop);
			STDMETHOD(get_ColorIndexBi)(WdColorIndex* prop);
			STDMETHOD(put_ColorIndexBi)(WdColorIndex prop);
			STDMETHOD(get_DiacriticColor)(WdColor* prop);
			STDMETHOD(put_DiacriticColor)(WdColor prop);
			STDMETHOD(get_UnderlineColor)(WdColor* prop);
			STDMETHOD(put_UnderlineColor)(WdColor prop);
		};
	}
}

#endif //_WORD_FONT_H_