
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _WORD_INLINE_SHAPE_H_
#define _WORD_INLINE_SHAPE_H_

#include "WordClone.h"

namespace AutomateIT
{
    namespace WordClone
    {
        class ATL_NO_VTABLE CWordInlineShape : 
            public CComObjectRootEx<CComSingleThreadModel>,
            public IDispatchImpl<InlineShape, &__uuidof(InlineShape), &LIBID_WordCloneLib, 8, 3>
        {
        public:
            CWordInlineShape();
            virtual ~CWordInlineShape();

            BEGIN_COM_MAP(CWordInlineShape)
                COM_INTERFACE_ENTRY(InlineShape)
                COM_INTERFACE_ENTRY(IDispatch)
            END_COM_MAP()

            DECLARE_PROTECT_FINAL_CONSTRUCT()

            HRESULT FinalConstruct()
            {
                return S_OK;
            }

            void FinalRelease() 
            {
            }

            STDMETHOD(get_Application)(IApplication** prop);
            STDMETHOD(get_Creator)(long* prop);
            STDMETHOD(get_Parent)(IDispatch** prop);
            STDMETHOD(get_Borders)(IDispatch** prop);
            STDMETHOD(put_Borders)(IDispatch* prop);
            STDMETHOD(get_Range)(Range** prop);
            STDMETHOD(get_LinkFormat)(IDispatch** prop);
            STDMETHOD(get_Field)(IDispatch** prop);
            STDMETHOD(get_OLEFormat)(IDispatch** prop);
            STDMETHOD(get_Type)(WdInlineShapeType* prop);
            STDMETHOD(get_Hyperlink)(IDispatch** prop);
            STDMETHOD(get_Height)(single* prop);
            STDMETHOD(put_Height)(single prop);
            STDMETHOD(get_Width)(single* prop);
            STDMETHOD(put_Width)(single prop);
            STDMETHOD(get_ScaleHeight)(single* prop);
            STDMETHOD(put_ScaleHeight)(single prop);
            STDMETHOD(get_ScaleWidth)(single* prop);
            STDMETHOD(put_ScaleWidth)(single prop);
            STDMETHOD(get_LockAspectRatio)(MsoTriState* prop);
            STDMETHOD(put_LockAspectRatio)(MsoTriState prop);
            STDMETHOD(get_Line)(IDispatch** prop);
            STDMETHOD(get_Fill)(IDispatch** prop);
            STDMETHOD(get_PictureFormat)(IDispatch** prop);
            STDMETHOD(put_PictureFormat)(IDispatch* prop);
            STDMETHOD(Activate)();
            STDMETHOD(Reset)();
            STDMETHOD(Delete)();
            STDMETHOD(Select)();
            STDMETHOD(ConvertToShape)(IDispatch** prop);
            STDMETHOD(HorizontalLineFormat)(IDispatch** prop);
            STDMETHOD(Script)(IDispatch** prop);
            STDMETHOD(OWSAnchor)(long* prop);
            STDMETHOD(TextEffect)(IDispatch** prop);
            STDMETHOD(TextEffect)(IDispatch* prop);
            STDMETHOD(AlternativeText)(BSTR* prop);
            STDMETHOD(AlternativeText)(BSTR prop);
            STDMETHOD(IsPictureBullet)(VARIANT_BOOL* prop);
        };
    }
}

#endif //_WORD_INLINE_SHAPE_H_