
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _WORD_LIST_LEVEL_H_
#define _WORD_LIST_LEVEL_H_

#include <atlcom.h>
#include "resource.h"       
#include "WordClone.h"
#include "WordFont.h"

namespace AutomateIT
{
	namespace WordClone
	{
		class ATL_NO_VTABLE CWordListLevel :
			public CComObjectRootEx<CComSingleThreadModel>,
			public IDispatchImpl<ListLevel, &__uuidof(ListLevel), &LIBID_WordCloneLib, 8, 3>
		{
		public:
			CWordListLevel();
			virtual ~CWordListLevel();

			BEGIN_COM_MAP(CWordListLevel)
				COM_INTERFACE_ENTRY(ListLevel)
			END_COM_MAP()

			DECLARE_PROTECT_FINAL_CONSTRUCT()

			HRESULT FinalConstruct()
			{
				return S_OK;
			}

			void FinalRelease()
			{
			}

			// ListLevel Methods
		public:
			STDMETHOD(get_Index)(long* prop);
			STDMETHOD(get_NumberFormat)(BSTR* prop);
			STDMETHOD(put_NumberFormat)(BSTR prop);
			STDMETHOD(get_TrailingCharacter)(WdTrailingCharacter* prop);
			STDMETHOD(put_TrailingCharacter)(WdTrailingCharacter prop);
			STDMETHOD(get_NumberStyle)(WdListNumberStyle* prop);
			STDMETHOD(put_NumberStyle)(WdListNumberStyle prop);
			STDMETHOD(get_NumberPosition)(float* prop);
			STDMETHOD(put_NumberPosition)(float prop);
			STDMETHOD(get_Alignment)(WdListLevelAlignment* prop);
			STDMETHOD(put_Alignment)(WdListLevelAlignment prop);
			STDMETHOD(get_TextPosition)(float* prop);
			STDMETHOD(put_TextPosition)(float prop);
			STDMETHOD(get_TabPosition)(float* prop);
			STDMETHOD(put_TabPosition)(float prop);
			STDMETHOD(get_ResetOnHigherOld)(VARIANT_BOOL* prop);
			STDMETHOD(put_ResetOnHigherOld)(VARIANT_BOOL prop);
			STDMETHOD(get_StartAt)(long* prop);
			STDMETHOD(put_StartAt)(long prop);
			STDMETHOD(get_LinkedStyle)(BSTR* prop);
			STDMETHOD(put_LinkedStyle)(BSTR prop);
			STDMETHOD(get_Font)(_Font** prop);
			STDMETHOD(put_Font)(_Font* prop);
			STDMETHOD(get_Application)(IApplication** prop);
			STDMETHOD(get_Creator)(long* prop);
			STDMETHOD(get_Parent)(LPDISPATCH* prop);
			STDMETHOD(get_ResetOnHigher)(long* prop);
			STDMETHOD(put_ResetOnHigher)(long prop);
			STDMETHOD(get_PictureBullet)(IDispatch** prop);
			STDMETHOD(ApplyPictureBullet)(BSTR FileName, IDispatch** prop);
		};

		typedef CComObject<CWordListLevel> WordListLevelObj;
		typedef CComPtr<CWordListLevel> WordListLevelPtr;
	}
}

#endif //_WORD_LIST_LEVEL_H_
