
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _WORD_OPTIONS_H_
#define _WORD_OPTIONS_H_

#include <atlcom.h>
#include "resource.h"
#include "WordClone.h"

namespace AutomateIT
{
	namespace WordClone
	{
		class CApplication;

		class ATL_NO_VTABLE CWordOptions :
			public CComObjectRootEx<CComSingleThreadModel>,
			public IDispatchImpl<Options, &__uuidof(Options), &LIBID_WordCloneLib, 8, 3>
		{
		public:
			CWordOptions();
			virtual ~CWordOptions();

			//DECLARE_REGISTRY_RESOURCEID(IDR_WORDOPTIONS)

			DECLARE_NOT_AGGREGATABLE(CWordOptions)

			BEGIN_COM_MAP(CWordOptions)
				COM_INTERFACE_ENTRY2(IDispatch, Options)
				COM_INTERFACE_ENTRY(Options)
			END_COM_MAP()


			DECLARE_PROTECT_FINAL_CONSTRUCT()

			HRESULT FinalConstruct()
			{
				return S_OK;
			}

			void FinalRelease() 
			{
			}

			// Options Methods
		public:
			STDMETHOD(get_Application)(IApplication** prop);
			STDMETHOD(get_Creator)(long* prop);
			STDMETHOD(get_Parent)(LPDISPATCH* prop);
			STDMETHOD(get_AllowAccentedUppercase)(VARIANT_BOOL* prop);
			STDMETHOD(put_AllowAccentedUppercase)(VARIANT_BOOL prop);
			STDMETHOD(get_WPHelp)(VARIANT_BOOL* prop);
			STDMETHOD(put_WPHelp)(VARIANT_BOOL prop);
			STDMETHOD(get_WPDocNavKeys)(VARIANT_BOOL* prop);
			STDMETHOD(put_WPDocNavKeys)(VARIANT_BOOL prop);
			STDMETHOD(get_Pagination)(VARIANT_BOOL* prop);
			STDMETHOD(put_Pagination)(VARIANT_BOOL prop);
			STDMETHOD(get_BlueScreen)(VARIANT_BOOL* prop);
			STDMETHOD(put_BlueScreen)(VARIANT_BOOL prop);
			STDMETHOD(get_EnableSound)(VARIANT_BOOL* prop);
			STDMETHOD(put_EnableSound)(VARIANT_BOOL prop);
			STDMETHOD(get_ConfirmConversions)(VARIANT_BOOL* prop);
			STDMETHOD(put_ConfirmConversions)(VARIANT_BOOL prop);
			STDMETHOD(get_UpdateLinksAtOpen)(VARIANT_BOOL* prop);
			STDMETHOD(put_UpdateLinksAtOpen)(VARIANT_BOOL prop);
			STDMETHOD(get_SendMailAttach)(VARIANT_BOOL* prop);
			STDMETHOD(put_SendMailAttach)(VARIANT_BOOL prop);
			STDMETHOD(get_MeasurementUnit)(WdMeasurementUnits* prop);
			STDMETHOD(put_MeasurementUnit)(WdMeasurementUnits prop);
			STDMETHOD(get_ButtonFieldClicks)(long* prop);
			STDMETHOD(put_ButtonFieldClicks)(long prop);
			STDMETHOD(get_ShortMenuNames)(VARIANT_BOOL* prop);
			STDMETHOD(put_ShortMenuNames)(VARIANT_BOOL prop);
			STDMETHOD(get_RTFInClipboard)(VARIANT_BOOL* prop);
			STDMETHOD(put_RTFInClipboard)(VARIANT_BOOL prop);
			STDMETHOD(get_UpdateFieldsAtPrint)(VARIANT_BOOL* prop);
			STDMETHOD(put_UpdateFieldsAtPrint)(VARIANT_BOOL prop);
			STDMETHOD(get_PrintProperties)(VARIANT_BOOL* prop);
			STDMETHOD(put_PrintProperties)(VARIANT_BOOL prop);
			STDMETHOD(get_PrintFieldCodes)(VARIANT_BOOL* prop);
			STDMETHOD(put_PrintFieldCodes)(VARIANT_BOOL prop);
			STDMETHOD(get_PrintComments)(VARIANT_BOOL* prop);
			STDMETHOD(put_PrintComments)(VARIANT_BOOL prop);
			STDMETHOD(get_PrintHiddenText)(VARIANT_BOOL* prop);
			STDMETHOD(put_PrintHiddenText)(VARIANT_BOOL prop);
			STDMETHOD(get_EnvelopeFeederInstalled)(VARIANT_BOOL* prop);
			STDMETHOD(get_UpdateLinksAtPrint)(VARIANT_BOOL* prop);
			STDMETHOD(put_UpdateLinksAtPrint)(VARIANT_BOOL prop);
			STDMETHOD(get_PrintBackground)(VARIANT_BOOL* prop);
			STDMETHOD(put_PrintBackground)(VARIANT_BOOL prop);
			STDMETHOD(get_PrintDrawingObjects)(VARIANT_BOOL* prop);
			STDMETHOD(put_PrintDrawingObjects)(VARIANT_BOOL prop);
			STDMETHOD(get_DefaultTray)(BSTR* prop);
			STDMETHOD(put_DefaultTray)(BSTR prop);
			STDMETHOD(get_DefaultTrayID)(long* prop);
			STDMETHOD(put_DefaultTrayID)(long prop);
			STDMETHOD(get_CreateBackup)(VARIANT_BOOL* prop);
			STDMETHOD(put_CreateBackup)(VARIANT_BOOL prop);
			STDMETHOD(get_AllowFastSave)(VARIANT_BOOL* prop);
			STDMETHOD(put_AllowFastSave)(VARIANT_BOOL prop);
			STDMETHOD(get_SavePropertiesPrompt)(VARIANT_BOOL* prop);
			STDMETHOD(put_SavePropertiesPrompt)(VARIANT_BOOL prop);
			STDMETHOD(get_SaveNormalPrompt)(VARIANT_BOOL* prop);
			STDMETHOD(put_SaveNormalPrompt)(VARIANT_BOOL prop);
			STDMETHOD(get_SaveInterval)(long* prop);
			STDMETHOD(put_SaveInterval)(long prop);
			STDMETHOD(get_BackgroundSave)(VARIANT_BOOL* prop);
			STDMETHOD(put_BackgroundSave)(VARIANT_BOOL prop);
			STDMETHOD(get_InsertedTextMark)(WdInsertedTextMark* prop);
			STDMETHOD(put_InsertedTextMark)(WdInsertedTextMark prop);
			STDMETHOD(get_DeletedTextMark)(WdDeletedTextMark* prop);
			STDMETHOD(put_DeletedTextMark)(WdDeletedTextMark prop);
			STDMETHOD(get_RevisedLinesMark)(WdRevisedLinesMark* prop);
			STDMETHOD(put_RevisedLinesMark)(WdRevisedLinesMark prop);
			STDMETHOD(get_InsertedTextColor)(WdColorIndex* prop);
			STDMETHOD(put_InsertedTextColor)(WdColorIndex prop);
			STDMETHOD(get_DeletedTextColor)(WdColorIndex* prop);
			STDMETHOD(put_DeletedTextColor)(WdColorIndex prop);
			STDMETHOD(get_RevisedLinesColor)(WdColorIndex* prop);
			STDMETHOD(put_RevisedLinesColor)(WdColorIndex prop);
			STDMETHOD(get_DefaultFilePath)(WdDefaultFilePath Path, BSTR* prop);
			STDMETHOD(put_DefaultFilePath)(WdDefaultFilePath Path, BSTR prop);
			STDMETHOD(get_Overtype)(VARIANT_BOOL* prop);
			STDMETHOD(put_Overtype)(VARIANT_BOOL prop);
			STDMETHOD(get_ReplaceSelection)(VARIANT_BOOL* prop);
			STDMETHOD(put_ReplaceSelection)(VARIANT_BOOL prop);
			STDMETHOD(get_AllowDragAndDrop)(VARIANT_BOOL* prop);
			STDMETHOD(put_AllowDragAndDrop)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoWordSelection)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoWordSelection)(VARIANT_BOOL prop);
			STDMETHOD(get_INSKeyForPaste)(VARIANT_BOOL* prop);
			STDMETHOD(put_INSKeyForPaste)(VARIANT_BOOL prop);
			STDMETHOD(get_SmartCutPaste)(VARIANT_BOOL* prop);
			STDMETHOD(put_SmartCutPaste)(VARIANT_BOOL prop);
			STDMETHOD(get_TabIndentKey)(VARIANT_BOOL* prop);
			STDMETHOD(put_TabIndentKey)(VARIANT_BOOL prop);
			STDMETHOD(get_PictureEditor)(BSTR* prop);
			STDMETHOD(put_PictureEditor)(BSTR prop);
			STDMETHOD(get_AnimateScreenMovements)(VARIANT_BOOL* prop);
			STDMETHOD(put_AnimateScreenMovements)(VARIANT_BOOL prop);
			STDMETHOD(get_VirusProtection)(VARIANT_BOOL* prop);
			STDMETHOD(put_VirusProtection)(VARIANT_BOOL prop);
			STDMETHOD(get_RevisedPropertiesMark)(WdRevisedPropertiesMark* prop);
			STDMETHOD(put_RevisedPropertiesMark)(WdRevisedPropertiesMark prop);
			STDMETHOD(get_RevisedPropertiesColor)(WdColorIndex* prop);
			STDMETHOD(put_RevisedPropertiesColor)(WdColorIndex prop);
			STDMETHOD(get_SnapToGrid)(VARIANT_BOOL* prop);
			STDMETHOD(put_SnapToGrid)(VARIANT_BOOL prop);
			STDMETHOD(get_SnapToShapes)(VARIANT_BOOL* prop);
			STDMETHOD(put_SnapToShapes)(VARIANT_BOOL prop);
			STDMETHOD(get_GridDistanceHorizontal)(float* prop);
			STDMETHOD(put_GridDistanceHorizontal)(float prop);
			STDMETHOD(get_GridDistanceVertical)(float* prop);
			STDMETHOD(put_GridDistanceVertical)(float prop);
			STDMETHOD(get_GridOriginHorizontal)(float* prop);
			STDMETHOD(put_GridOriginHorizontal)(float prop);
			STDMETHOD(get_GridOriginVertical)(float* prop);
			STDMETHOD(put_GridOriginVertical)(float prop);
			STDMETHOD(get_InlineConversion)(VARIANT_BOOL* prop);
			STDMETHOD(put_InlineConversion)(VARIANT_BOOL prop);
			STDMETHOD(get_IMEAutomaticControl)(VARIANT_BOOL* prop);
			STDMETHOD(put_IMEAutomaticControl)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatApplyHeadings)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatApplyHeadings)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatApplyLists)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatApplyLists)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatApplyBulletedLists)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatApplyBulletedLists)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatApplyOtherParas)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatApplyOtherParas)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatReplaceQuotes)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatReplaceQuotes)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatReplaceSymbols)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatReplaceSymbols)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatReplaceOrdinals)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatReplaceOrdinals)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatReplaceFractions)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatReplaceFractions)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatReplacePlainTextEmphasis)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatReplacePlainTextEmphasis)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatPreserveStyles)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatPreserveStyles)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatAsYouTypeApplyHeadings)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatAsYouTypeApplyHeadings)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatAsYouTypeApplyBorders)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatAsYouTypeApplyBorders)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatAsYouTypeApplyBulletedLists)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatAsYouTypeApplyBulletedLists)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatAsYouTypeApplyNumberedLists)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatAsYouTypeApplyNumberedLists)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatAsYouTypeReplaceQuotes)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatAsYouTypeReplaceQuotes)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatAsYouTypeReplaceSymbols)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatAsYouTypeReplaceSymbols)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatAsYouTypeReplaceOrdinals)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatAsYouTypeReplaceOrdinals)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatAsYouTypeReplaceFractions)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatAsYouTypeReplaceFractions)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatAsYouTypeReplacePlainTextEmphasis)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatAsYouTypeReplacePlainTextEmphasis)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatAsYouTypeFormatListItemBeginning)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatAsYouTypeFormatListItemBeginning)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatAsYouTypeDefineStyles)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatAsYouTypeDefineStyles)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatPlainTextWordMail)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatPlainTextWordMail)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatAsYouTypeReplaceHyperlinks)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatAsYouTypeReplaceHyperlinks)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatReplaceHyperlinks)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatReplaceHyperlinks)(VARIANT_BOOL prop);
			STDMETHOD(get_DefaultHighlightColorIndex)(WdColorIndex* prop);
			STDMETHOD(put_DefaultHighlightColorIndex)(WdColorIndex prop);
			STDMETHOD(get_DefaultBorderLineStyle)(WdLineStyle* prop);
			STDMETHOD(put_DefaultBorderLineStyle)(WdLineStyle prop);
			STDMETHOD(get_CheckSpellingAsYouType)(VARIANT_BOOL* prop);
			STDMETHOD(put_CheckSpellingAsYouType)(VARIANT_BOOL prop);
			STDMETHOD(get_CheckGrammarAsYouType)(VARIANT_BOOL* prop);
			STDMETHOD(put_CheckGrammarAsYouType)(VARIANT_BOOL prop);
			STDMETHOD(get_IgnoreInternetAndFileAddresses)(VARIANT_BOOL* prop);
			STDMETHOD(put_IgnoreInternetAndFileAddresses)(VARIANT_BOOL prop);
			STDMETHOD(get_ShowReadabilityStatistics)(VARIANT_BOOL* prop);
			STDMETHOD(put_ShowReadabilityStatistics)(VARIANT_BOOL prop);
			STDMETHOD(get_IgnoreUppercase)(VARIANT_BOOL* prop);
			STDMETHOD(put_IgnoreUppercase)(VARIANT_BOOL prop);
			STDMETHOD(get_IgnoreMixedDigits)(VARIANT_BOOL* prop);
			STDMETHOD(put_IgnoreMixedDigits)(VARIANT_BOOL prop);
			STDMETHOD(get_SuggestFromMainDictionaryOnly)(VARIANT_BOOL* prop);
			STDMETHOD(put_SuggestFromMainDictionaryOnly)(VARIANT_BOOL prop);
			STDMETHOD(get_SuggestSpellingCorrections)(VARIANT_BOOL* prop);
			STDMETHOD(put_SuggestSpellingCorrections)(VARIANT_BOOL prop);
			STDMETHOD(get_DefaultBorderLineWidth)(WdLineWidth* prop);
			STDMETHOD(put_DefaultBorderLineWidth)(WdLineWidth prop);
			STDMETHOD(get_CheckGrammarWithSpelling)(VARIANT_BOOL* prop);
			STDMETHOD(put_CheckGrammarWithSpelling)(VARIANT_BOOL prop);
			STDMETHOD(get_DefaultOpenFormat)(WdOpenFormat* prop);
			STDMETHOD(put_DefaultOpenFormat)(WdOpenFormat prop);
			STDMETHOD(get_PrintDraft)(VARIANT_BOOL* prop);
			STDMETHOD(put_PrintDraft)(VARIANT_BOOL prop);
			STDMETHOD(get_PrintReverse)(VARIANT_BOOL* prop);
			STDMETHOD(put_PrintReverse)(VARIANT_BOOL prop);
			STDMETHOD(get_MapPaperSize)(VARIANT_BOOL* prop);
			STDMETHOD(put_MapPaperSize)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatAsYouTypeApplyTables)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatAsYouTypeApplyTables)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatApplyFirstIndents)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatApplyFirstIndents)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatMatchParentheses)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatMatchParentheses)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatReplaceFarEastDashes)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatReplaceFarEastDashes)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatDeleteAutoSpaces)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatDeleteAutoSpaces)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatAsYouTypeApplyFirstIndents)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatAsYouTypeApplyFirstIndents)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatAsYouTypeApplyDates)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatAsYouTypeApplyDates)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatAsYouTypeApplyClosings)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatAsYouTypeApplyClosings)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatAsYouTypeMatchParentheses)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatAsYouTypeMatchParentheses)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatAsYouTypeReplaceFarEastDashes)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatAsYouTypeReplaceFarEastDashes)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatAsYouTypeDeleteAutoSpaces)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatAsYouTypeDeleteAutoSpaces)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatAsYouTypeInsertClosings)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatAsYouTypeInsertClosings)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatAsYouTypeAutoLetterWizard)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatAsYouTypeAutoLetterWizard)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoFormatAsYouTypeInsertOvers)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoFormatAsYouTypeInsertOvers)(VARIANT_BOOL prop);
			STDMETHOD(get_DisplayGridLines)(VARIANT_BOOL* prop);
			STDMETHOD(put_DisplayGridLines)(VARIANT_BOOL prop);
			STDMETHOD(get_MatchFuzzyCase)(VARIANT_BOOL* prop);
			STDMETHOD(put_MatchFuzzyCase)(VARIANT_BOOL prop);
			STDMETHOD(get_MatchFuzzyByte)(VARIANT_BOOL* prop);
			STDMETHOD(put_MatchFuzzyByte)(VARIANT_BOOL prop);
			STDMETHOD(get_MatchFuzzyHiragana)(VARIANT_BOOL* prop);
			STDMETHOD(put_MatchFuzzyHiragana)(VARIANT_BOOL prop);
			STDMETHOD(get_MatchFuzzySmallKana)(VARIANT_BOOL* prop);
			STDMETHOD(put_MatchFuzzySmallKana)(VARIANT_BOOL prop);
			STDMETHOD(get_MatchFuzzyDash)(VARIANT_BOOL* prop);
			STDMETHOD(put_MatchFuzzyDash)(VARIANT_BOOL prop);
			STDMETHOD(get_MatchFuzzyIterationMark)(VARIANT_BOOL* prop);
			STDMETHOD(put_MatchFuzzyIterationMark)(VARIANT_BOOL prop);
			STDMETHOD(get_MatchFuzzyKanji)(VARIANT_BOOL* prop);
			STDMETHOD(put_MatchFuzzyKanji)(VARIANT_BOOL prop);
			STDMETHOD(get_MatchFuzzyOldKana)(VARIANT_BOOL* prop);
			STDMETHOD(put_MatchFuzzyOldKana)(VARIANT_BOOL prop);
			STDMETHOD(get_MatchFuzzyProlongedSoundMark)(VARIANT_BOOL* prop);
			STDMETHOD(put_MatchFuzzyProlongedSoundMark)(VARIANT_BOOL prop);
			STDMETHOD(get_MatchFuzzyDZ)(VARIANT_BOOL* prop);
			STDMETHOD(put_MatchFuzzyDZ)(VARIANT_BOOL prop);
			STDMETHOD(get_MatchFuzzyBV)(VARIANT_BOOL* prop);
			STDMETHOD(put_MatchFuzzyBV)(VARIANT_BOOL prop);
			STDMETHOD(get_MatchFuzzyTC)(VARIANT_BOOL* prop);
			STDMETHOD(put_MatchFuzzyTC)(VARIANT_BOOL prop);
			STDMETHOD(get_MatchFuzzyHF)(VARIANT_BOOL* prop);
			STDMETHOD(put_MatchFuzzyHF)(VARIANT_BOOL prop);
			STDMETHOD(get_MatchFuzzyZJ)(VARIANT_BOOL* prop);
			STDMETHOD(put_MatchFuzzyZJ)(VARIANT_BOOL prop);
			STDMETHOD(get_MatchFuzzyAY)(VARIANT_BOOL* prop);
			STDMETHOD(put_MatchFuzzyAY)(VARIANT_BOOL prop);
			STDMETHOD(get_MatchFuzzyKiKu)(VARIANT_BOOL* prop);
			STDMETHOD(put_MatchFuzzyKiKu)(VARIANT_BOOL prop);
			STDMETHOD(get_MatchFuzzyPunctuation)(VARIANT_BOOL* prop);
			STDMETHOD(put_MatchFuzzyPunctuation)(VARIANT_BOOL prop);
			STDMETHOD(get_MatchFuzzySpace)(VARIANT_BOOL* prop);
			STDMETHOD(put_MatchFuzzySpace)(VARIANT_BOOL prop);
			STDMETHOD(get_ApplyFarEastFontsToAscii)(VARIANT_BOOL* prop);
			STDMETHOD(put_ApplyFarEastFontsToAscii)(VARIANT_BOOL prop);
			STDMETHOD(get_ConvertHighAnsiToFarEast)(VARIANT_BOOL* prop);
			STDMETHOD(put_ConvertHighAnsiToFarEast)(VARIANT_BOOL prop);
			STDMETHOD(get_PrintOddPagesInAscendingOrder)(VARIANT_BOOL* prop);
			STDMETHOD(put_PrintOddPagesInAscendingOrder)(VARIANT_BOOL prop);
			STDMETHOD(get_PrintEvenPagesInAscendingOrder)(VARIANT_BOOL* prop);
			STDMETHOD(put_PrintEvenPagesInAscendingOrder)(VARIANT_BOOL prop);
			STDMETHOD(get_DefaultBorderColorIndex)(WdColorIndex* prop);
			STDMETHOD(put_DefaultBorderColorIndex)(WdColorIndex prop);
			STDMETHOD(get_EnableMisusedWordsDictionary)(VARIANT_BOOL* prop);
			STDMETHOD(put_EnableMisusedWordsDictionary)(VARIANT_BOOL prop);
			STDMETHOD(get_AllowCombinedAuxiliaryForms)(VARIANT_BOOL* prop);
			STDMETHOD(put_AllowCombinedAuxiliaryForms)(VARIANT_BOOL prop);
			STDMETHOD(get_HangulHanjaFastConversion)(VARIANT_BOOL* prop);
			STDMETHOD(put_HangulHanjaFastConversion)(VARIANT_BOOL prop);
			STDMETHOD(get_CheckHangulEndings)(VARIANT_BOOL* prop);
			STDMETHOD(put_CheckHangulEndings)(VARIANT_BOOL prop);
			STDMETHOD(get_EnableHangulHanjaRecentOrdering)(VARIANT_BOOL* prop);
			STDMETHOD(put_EnableHangulHanjaRecentOrdering)(VARIANT_BOOL prop);
			STDMETHOD(get_MultipleWordConversionsMode)(WdMultipleWordConversionsMode* prop);
			STDMETHOD(put_MultipleWordConversionsMode)(WdMultipleWordConversionsMode prop);
			STDMETHOD(SetWPHelpOptions)(VARIANT* CommandKeyHelp, VARIANT* DocNavigationKeys, VARIANT* MouseSimulation, VARIANT* DemoGuidance, VARIANT* DemoSpeed, VARIANT* HelpType);
			STDMETHOD(get_DefaultBorderColor)(WdColor* prop);
			STDMETHOD(put_DefaultBorderColor)(WdColor prop);
			STDMETHOD(get_AllowPixelUnits)(VARIANT_BOOL* prop);
			STDMETHOD(put_AllowPixelUnits)(VARIANT_BOOL prop);
			STDMETHOD(get_UseCharacterUnit)(VARIANT_BOOL* prop);
			STDMETHOD(put_UseCharacterUnit)(VARIANT_BOOL prop);
			STDMETHOD(get_AllowCompoundNounProcessing)(VARIANT_BOOL* prop);
			STDMETHOD(put_AllowCompoundNounProcessing)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoKeyboardSwitching)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoKeyboardSwitching)(VARIANT_BOOL prop);
			STDMETHOD(get_DocumentViewDirection)(WdDocumentViewDirection* prop);
			STDMETHOD(put_DocumentViewDirection)(WdDocumentViewDirection prop);
			STDMETHOD(get_ArabicNumeral)(WdArabicNumeral* prop);
			STDMETHOD(put_ArabicNumeral)(WdArabicNumeral prop);
			STDMETHOD(get_MonthNames)(WdMonthNames* prop);
			STDMETHOD(put_MonthNames)(WdMonthNames prop);
			STDMETHOD(get_CursorMovement)(WdCursorMovement* prop);
			STDMETHOD(put_CursorMovement)(WdCursorMovement prop);
			STDMETHOD(get_VisualSelection)(WdVisualSelection* prop);
			STDMETHOD(put_VisualSelection)(WdVisualSelection prop);
			STDMETHOD(get_ShowDiacritics)(VARIANT_BOOL* prop);
			STDMETHOD(put_ShowDiacritics)(VARIANT_BOOL prop);
			STDMETHOD(get_ShowControlCharacters)(VARIANT_BOOL* prop);
			STDMETHOD(put_ShowControlCharacters)(VARIANT_BOOL prop);
			STDMETHOD(get_AddControlCharacters)(VARIANT_BOOL* prop);
			STDMETHOD(put_AddControlCharacters)(VARIANT_BOOL prop);
			STDMETHOD(get_AddBiDirectionalMarksWhenSavingTextFile)(VARIANT_BOOL* prop);
			STDMETHOD(put_AddBiDirectionalMarksWhenSavingTextFile)(VARIANT_BOOL prop);
			STDMETHOD(get_StrictInitialAlefHamza)(VARIANT_BOOL* prop);
			STDMETHOD(put_StrictInitialAlefHamza)(VARIANT_BOOL prop);
			STDMETHOD(get_StrictFinalYaa)(VARIANT_BOOL* prop);
			STDMETHOD(put_StrictFinalYaa)(VARIANT_BOOL prop);
			STDMETHOD(get_HebrewMode)(WdHebSpellStart* prop);
			STDMETHOD(put_HebrewMode)(WdHebSpellStart prop);
			STDMETHOD(get_ArabicMode)(WdAraSpeller* prop);
			STDMETHOD(put_ArabicMode)(WdAraSpeller prop);
			STDMETHOD(get_AllowClickAndTypeMouse)(VARIANT_BOOL* prop);
			STDMETHOD(put_AllowClickAndTypeMouse)(VARIANT_BOOL prop);
			STDMETHOD(get_UseGermanSpellingReform)(VARIANT_BOOL* prop);
			STDMETHOD(put_UseGermanSpellingReform)(VARIANT_BOOL prop);
			STDMETHOD(get_InterpretHighAnsi)(WdHighAnsiText* prop);
			STDMETHOD(put_InterpretHighAnsi)(WdHighAnsiText prop);
			STDMETHOD(get_AddHebDoubleQuote)(VARIANT_BOOL* prop);
			STDMETHOD(put_AddHebDoubleQuote)(VARIANT_BOOL prop);
			STDMETHOD(get_UseDiffDiacColor)(VARIANT_BOOL* prop);
			STDMETHOD(put_UseDiffDiacColor)(VARIANT_BOOL prop);
			STDMETHOD(get_DiacriticColorVal)(WdColor* prop);
			STDMETHOD(put_DiacriticColorVal)(WdColor prop);
			STDMETHOD(get_OptimizeForWord97byDefault)(VARIANT_BOOL* prop);
			STDMETHOD(put_OptimizeForWord97byDefault)(VARIANT_BOOL prop);
			STDMETHOD(get_LocalNetworkFile)(VARIANT_BOOL* prop);
			STDMETHOD(put_LocalNetworkFile)(VARIANT_BOOL prop);
			STDMETHOD(get_TypeNReplace)(VARIANT_BOOL* prop);
			STDMETHOD(put_TypeNReplace)(VARIANT_BOOL prop);
			STDMETHOD(get_SequenceCheck)(VARIANT_BOOL* prop);
			STDMETHOD(put_SequenceCheck)(VARIANT_BOOL prop);
			STDMETHOD(get_BackgroundOpen)(VARIANT_BOOL* prop);
			STDMETHOD(put_BackgroundOpen)(VARIANT_BOOL prop);
			STDMETHOD(get_DisableFeaturesbyDefault)(VARIANT_BOOL* prop);
			STDMETHOD(put_DisableFeaturesbyDefault)(VARIANT_BOOL prop);
			STDMETHOD(get_PasteAdjustWordSpacing)(VARIANT_BOOL* prop);
			STDMETHOD(put_PasteAdjustWordSpacing)(VARIANT_BOOL prop);
			STDMETHOD(get_PasteAdjustParagraphSpacing)(VARIANT_BOOL* prop);
			STDMETHOD(put_PasteAdjustParagraphSpacing)(VARIANT_BOOL prop);
			STDMETHOD(get_PasteAdjustTableFormatting)(VARIANT_BOOL* prop);
			STDMETHOD(put_PasteAdjustTableFormatting)(VARIANT_BOOL prop);
			STDMETHOD(get_PasteSmartStyleBehavior)(VARIANT_BOOL* prop);
			STDMETHOD(put_PasteSmartStyleBehavior)(VARIANT_BOOL prop);
			STDMETHOD(get_PasteMergeFromPPT)(VARIANT_BOOL* prop);
			STDMETHOD(put_PasteMergeFromPPT)(VARIANT_BOOL prop);
			STDMETHOD(get_PasteMergeFromXL)(VARIANT_BOOL* prop);
			STDMETHOD(put_PasteMergeFromXL)(VARIANT_BOOL prop);
			STDMETHOD(get_CtrlClickHyperlinkToOpen)(VARIANT_BOOL* prop);
			STDMETHOD(put_CtrlClickHyperlinkToOpen)(VARIANT_BOOL prop);
			STDMETHOD(get_PictureWrapType)(WdWrapTypeMerged* prop);
			STDMETHOD(put_PictureWrapType)(WdWrapTypeMerged prop);
			STDMETHOD(get_DisableFeaturesIntroducedAfterbyDefault)(WdDisableFeaturesIntroducedAfter* prop);
			STDMETHOD(put_DisableFeaturesIntroducedAfterbyDefault)(WdDisableFeaturesIntroducedAfter prop);
			STDMETHOD(get_PasteSmartCutPaste)(VARIANT_BOOL* prop);
			STDMETHOD(put_PasteSmartCutPaste)(VARIANT_BOOL prop);
			STDMETHOD(get_DisplayPasteOptions)(VARIANT_BOOL* prop);
			STDMETHOD(put_DisplayPasteOptions)(VARIANT_BOOL prop);
			STDMETHOD(get_PromptUpdateStyle)(VARIANT_BOOL* prop);
			STDMETHOD(put_PromptUpdateStyle)(VARIANT_BOOL prop);
			STDMETHOD(get_DefaultEPostageApp)(BSTR* prop);
			STDMETHOD(put_DefaultEPostageApp)(BSTR prop);
			STDMETHOD(get_DefaultTextEncoding)(MsoEncoding* prop);
			STDMETHOD(put_DefaultTextEncoding)(MsoEncoding prop);
			STDMETHOD(get_LabelSmartTags)(VARIANT_BOOL* prop);
			STDMETHOD(put_LabelSmartTags)(VARIANT_BOOL prop);
			STDMETHOD(get_DisplaySmartTagButtons)(VARIANT_BOOL* prop);
			STDMETHOD(put_DisplaySmartTagButtons)(VARIANT_BOOL prop);
			STDMETHOD(get_WarnBeforeSavingPrintingSendingMarkup)(VARIANT_BOOL* prop);
			STDMETHOD(put_WarnBeforeSavingPrintingSendingMarkup)(VARIANT_BOOL prop);
			STDMETHOD(get_StoreRSIDOnSave)(VARIANT_BOOL* prop);
			STDMETHOD(put_StoreRSIDOnSave)(VARIANT_BOOL prop);
			STDMETHOD(get_ShowFormatError)(VARIANT_BOOL* prop);
			STDMETHOD(put_ShowFormatError)(VARIANT_BOOL prop);
			STDMETHOD(get_FormatScanning)(VARIANT_BOOL* prop);
			STDMETHOD(put_FormatScanning)(VARIANT_BOOL prop);
			STDMETHOD(get_PasteMergeLists)(VARIANT_BOOL* prop);
			STDMETHOD(put_PasteMergeLists)(VARIANT_BOOL prop);
			STDMETHOD(get_AutoCreateNewDrawings)(VARIANT_BOOL* prop);
			STDMETHOD(put_AutoCreateNewDrawings)(VARIANT_BOOL prop);
			STDMETHOD(get_SmartParaSelection)(VARIANT_BOOL* prop);
			STDMETHOD(put_SmartParaSelection)(VARIANT_BOOL prop);
			STDMETHOD(get_RevisionsBalloonPrintOrientation)(WdRevisionsBalloonPrintOrientation* prop);
			STDMETHOD(put_RevisionsBalloonPrintOrientation)(WdRevisionsBalloonPrintOrientation prop);
			STDMETHOD(get_CommentsColor)(WdColorIndex* prop);
			STDMETHOD(put_CommentsColor)(WdColorIndex prop);
			STDMETHOD(get_PrintXMLTag)(VARIANT_BOOL* prop);
			STDMETHOD(put_PrintXMLTag)(VARIANT_BOOL prop);
			STDMETHOD(get_PrintBackgrounds)(VARIANT_BOOL* prop);
			STDMETHOD(put_PrintBackgrounds)(VARIANT_BOOL prop);
			STDMETHOD(get_AllowReadingMode)(VARIANT_BOOL* prop);
			STDMETHOD(put_AllowReadingMode)(VARIANT_BOOL prop);
			STDMETHOD(get_ShowMarkupOpenSave)(VARIANT_BOOL* prop);
			STDMETHOD(put_ShowMarkupOpenSave)(VARIANT_BOOL prop);
			STDMETHOD(get_SmartCursoring)(VARIANT_BOOL* prop);
			STDMETHOD(put_SmartCursoring)(VARIANT_BOOL prop);
		};
	}
}

#endif //_WORD_OPTIONS_H_