
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _WORD_PARAGRAPHS_H_
#define _WORD_PARAGRAPHS_H_

#include "WordParagraph.h"

namespace AutomateIT
{
    namespace WordClone
    {
        class ATL_NO_VTABLE CWordParagraphs : 
            public CComObjectRootEx<CComSingleThreadModel>,
            public IDispatchImpl<Paragraphs, &__uuidof(Paragraphs), &LIBID_WordCloneLib, 8, 3>
        {
        public:
            CWordParagraphs();
            virtual ~CWordParagraphs();

            BEGIN_COM_MAP(CWordParagraphs)
                COM_INTERFACE_ENTRY(Paragraphs)
                COM_INTERFACE_ENTRY(IDispatch)
            END_COM_MAP()

            DECLARE_PROTECT_FINAL_CONSTRUCT()

            HRESULT FinalConstruct()
            {
                return S_OK;
            }

            void FinalRelease() 
            {
            }

            STDMETHOD(get__NewEnum)(IUnknown** prop);
            STDMETHOD(get_Count)(long* prop);
            STDMETHOD(get_First)(Paragraph** prop);
            STDMETHOD(get_Last)(Paragraph** prop);
            STDMETHOD(get_Application)(IApplication** prop);
            STDMETHOD(get_Creator)(long* prop);
            STDMETHOD(get_Parent)(IDispatch** prop);
            STDMETHOD(get_Format)(IDispatch** prop);
            STDMETHOD(put_Format)(IDispatch* prop);
            STDMETHOD(get_TabStops)(TabStops** prop);
            STDMETHOD(put_TabStops)(TabStops* prop);
            STDMETHOD(get_Borders)(IDispatch** prop);
            STDMETHOD(put_Borders)(IDispatch* prop);
            STDMETHOD(get_Style)(VARIANT* prop);
            STDMETHOD(put_Style)(VARIANT* prop);
            STDMETHOD(get_Alignment)(WdParagraphAlignment* prop);
            STDMETHOD(put_Alignment)(WdParagraphAlignment prop);
            STDMETHOD(get_KeepTogether)(long* prop);
            STDMETHOD(put_KeepTogether)(long prop);
            STDMETHOD(get_KeepWithNext)(long* prop);
            STDMETHOD(put_KeepWithNext)(long prop);
            STDMETHOD(get_PageBreakBefore)(long* prop);
            STDMETHOD(put_PageBreakBefore)(long prop);
            STDMETHOD(get_NoLineNumber)(long* prop);
            STDMETHOD(put_NoLineNumber)(long prop);
            STDMETHOD(get_RightIndent)(single* prop);
            STDMETHOD(put_RightIndent)(single prop);
            STDMETHOD(get_LeftIndent)(single* prop);
            STDMETHOD(put_LeftIndent)(single prop);
            STDMETHOD(get_FirstLineIndent)(single* prop);
            STDMETHOD(put_FirstLineIndent)(single prop);
            STDMETHOD(get_LineSpacing)(single* prop);
            STDMETHOD(put_LineSpacing)(single prop);
            STDMETHOD(get_LineSpacingRule)(WdLineSpacing* prop);
            STDMETHOD(put_LineSpacingRule)(WdLineSpacing prop);
            STDMETHOD(get_SpaceBefore)(single* prop);
            STDMETHOD(put_SpaceBefore)(single prop);
            STDMETHOD(get_SpaceAfter)(single* prop);
            STDMETHOD(put_SpaceAfter)(single prop);
            STDMETHOD(get_Hyphenation)(long* prop);
            STDMETHOD(put_Hyphenation)(long prop);
            STDMETHOD(get_WidowControl)(long* prop);
            STDMETHOD(put_WidowControl)(long prop);
            STDMETHOD(get_Shading)(IDispatch** prop);
            STDMETHOD(get_FarEastLineBreakControl)(long* prop);
            STDMETHOD(put_FarEastLineBreakControl)(long prop);
            STDMETHOD(get_WordWrap)(long* prop);
            STDMETHOD(put_WordWrap)(long prop);
            STDMETHOD(get_HangingPunctuation)(long* prop);
            STDMETHOD(put_HangingPunctuation)(long prop);
            STDMETHOD(get_HalfWidthPunctuationOnTopOfLine)(long* prop);
            STDMETHOD(put_HalfWidthPunctuationOnTopOfLine)(long prop);
            STDMETHOD(get_AddSpaceBetweenFarEastAndAlpha)(long* prop);
            STDMETHOD(put_AddSpaceBetweenFarEastAndAlpha)(long prop);
            STDMETHOD(get_AddSpaceBetweenFarEastAndDigit)(long* prop);
            STDMETHOD(put_AddSpaceBetweenFarEastAndDigit)(long prop);
            STDMETHOD(get_BaseLineAlignment)(WdBaselineAlignment* prop);
            STDMETHOD(put_BaseLineAlignment)(WdBaselineAlignment prop);
            STDMETHOD(get_AutoAdjustRightIndent)(long* prop);
            STDMETHOD(put_AutoAdjustRightIndent)(long prop);
            STDMETHOD(get_DisableLineHeightGrid)(long* prop);
            STDMETHOD(put_DisableLineHeightGrid)(long prop);
            STDMETHOD(get_OutlineLevel)(WdOutlineLevel* prop);
            STDMETHOD(put_OutlineLevel)(WdOutlineLevel prop);
            STDMETHOD(get_Item)(long Index, Paragraph** prop);
            STDMETHOD(Add)(VARIANT* Range, Paragraph** prop);
            STDMETHOD(CloseUp)();
            STDMETHOD(OpenUp)();
            STDMETHOD(OpenOrCloseUp)();
            STDMETHOD(TabHangingIndent)(short Count);
            STDMETHOD(TabIndent)(short Count);
            STDMETHOD(Reset)();
            STDMETHOD(Space1)();
            STDMETHOD(Space15)();
            STDMETHOD(Space2)();
            STDMETHOD(IndentCharWidth)(short Count);
            STDMETHOD(IndentFirstLineCharWidth)(short Count);
            STDMETHOD(OutlinePromote)();
            STDMETHOD(OutlineDemote)();
            STDMETHOD(OutlineDemoteToBody)();
            STDMETHOD(Indent)();
            STDMETHOD(Outdent)();
            STDMETHOD(get_CharacterUnitRightIndent)(single* prop);
            STDMETHOD(put_CharacterUnitRightIndent)(single prop);
            STDMETHOD(get_CharacterUnitLeftIndent)(single* prop);
            STDMETHOD(put_CharacterUnitLeftIndent)(single prop);
            STDMETHOD(get_CharacterUnitFirstLineIndent)(single* prop);
            STDMETHOD(put_CharacterUnitFirstLineIndent)(single prop);
            STDMETHOD(get_LineUnitBefore)(single* prop);
            STDMETHOD(put_LineUnitBefore)(single prop);
            STDMETHOD(get_LineUnitAfter)(single* prop);
            STDMETHOD(put_LineUnitAfter)(single prop);
            STDMETHOD(get_ReadingOrder)(WdReadingOrder* prop);
            STDMETHOD(put_ReadingOrder)(WdReadingOrder prop);
            STDMETHOD(get_SpaceBeforeAuto)(long* prop);
            STDMETHOD(put_SpaceBeforeAuto)(long prop);
            STDMETHOD(get_SpaceAfterAuto)(long* prop);
            STDMETHOD(put_SpaceAfterAuto)(long prop);
            STDMETHOD(IncreaseSpacing)();
            STDMETHOD(DecreaseSpacing)();
        };
    }
}

#endif //_WORD_PARAGRAPHS_H_