
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _WORD_STYLES_COLLECTION_H_
#define _WORD_STYLES_COLLECTION_H_

#include <atlcom.h>
#include <atlcoll.h>
#include "resource.h"
#include "WordClone.h"
#include "WordStyle.h"

namespace AutomateIT
{
	namespace WordClone
	{
		class CWordDocument;

		typedef CAtlList<WordStylePtr> ListStyles;

		class ATL_NO_VTABLE CWordStylesCollection :
			public CComObjectRootEx<CComSingleThreadModel>,
			public IDispatchImpl<Styles, &__uuidof(Styles), &LIBID_WordCloneLib, 8, 3>
		{
		public:
			CWordStylesCollection();
			virtual ~CWordStylesCollection();

			//DECLARE_REGISTRY_RESOURCEID(IDR_WORDSTYLESCOLLECTION)
			BEGIN_COM_MAP(CWordStylesCollection)
				COM_INTERFACE_ENTRY(Styles)
			END_COM_MAP()

			DECLARE_PROTECT_FINAL_CONSTRUCT()

			HRESULT FinalConstruct()
			{
				return S_OK;
			}

			void FinalRelease() 
			{
			}

			// Styles Methods
		public:
			STDMETHOD(get_Application)(IApplication** prop);
			STDMETHOD(get_Creator)(long* prop);
			STDMETHOD(get_Parent)(LPDISPATCH* prop);
			STDMETHOD(get__NewEnum)(LPUNKNOWN* prop);
			STDMETHOD(get_Count)(long* prop);
			STDMETHOD(get_Item)(VARIANT* Index, Style** prop);
			STDMETHOD(Add)(BSTR Name, VARIANT* Type, Style** prop);
		};
	}
}

#endif //_WORD_STYLES_COLLECTION_H_

