
/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/

#ifndef _WORD_TABLES_OF_CONTENTS_H_
#define _WORD_TABLES_OF_CONTENTS_H_

#include "WordClone.h"

namespace AutomateIT
{
    namespace WordClone
    {
        class ATL_NO_VTABLE CWordTablesOfContents : 
            public CComObjectRootEx<CComSingleThreadModel>,
            public IDispatchImpl<TablesOfContents, &__uuidof(TablesOfContents), &LIBID_WordCloneLib, 8, 3>
        {
        public:
            CWordTablesOfContents();
            virtual ~CWordTablesOfContents();

            BEGIN_COM_MAP(CWordTablesOfContents)
                COM_INTERFACE_ENTRY(TablesOfContents)
                COM_INTERFACE_ENTRY(IDispatch)
            END_COM_MAP()

            DECLARE_PROTECT_FINAL_CONSTRUCT()

            HRESULT FinalConstruct()
            {
                return S_OK;
            }

            void FinalRelease() 
            {
            }

            STDMETHOD(get_Application)(IApplication** prop);
            STDMETHOD(get_Creator)(long* prop);
            STDMETHOD(get_Parent)(IDispatch** prop);
            STDMETHOD(get__NewEnum)(IUnknown** prop);
            STDMETHOD(get_Count)(long* prop);
            STDMETHOD(get_Format)(WdTocFormat* prop);
            STDMETHOD(put_Format)(WdTocFormat prop);
            STDMETHOD(get_Item)(long Index, TableOfContents** prop);
            STDMETHOD(AddOld)(Range* Range, VARIANT* UseHeadingStyles, VARIANT* UpperHeadingLevel, VARIANT* LowerHeadingLevel, VARIANT* UseFields, VARIANT* TableID, VARIANT* RightAlignPageNumbers, VARIANT* IncludePageNumbers, VARIANT* AddedStyles, TableOfContents** prop);
            STDMETHOD(MarkEntry)(Range* Range, VARIANT* Entry, VARIANT* EntryAutoText, VARIANT* TableID, VARIANT* Level, IDispatch** prop);
            STDMETHOD(Add2000)(Range* Range, VARIANT* UseHeadingStyles, VARIANT* UpperHeadingLevel, VARIANT* LowerHeadingLevel, VARIANT* UseFields, VARIANT* TableID, VARIANT* RightAlignPageNumbers, VARIANT* IncludePageNumbers, VARIANT* AddedStyles, VARIANT* UseHyperlinks, VARIANT* HidePageNumbersInWeb, TableOfContents** prop);
            STDMETHOD(Add)(Range* Range, VARIANT* UseHeadingStyles, VARIANT* UpperHeadingLevel, VARIANT* LowerHeadingLevel, VARIANT* UseFields, VARIANT* TableID, VARIANT* RightAlignPageNumbers, VARIANT* IncludePageNumbers, VARIANT* AddedStyles, VARIANT* UseHyperlinks, VARIANT* HidePageNumbersInWeb, VARIANT* UseOutlineLevels, TableOfContents** prop);
        };
    }
}

#endif //_WORD_TABLES_OF_CONTENTS_H_